#include<iostream.h>
#include<string.h>
#include"dataserver.h"



void main()
{

	cerr << "Creating Table\n";

	cDataTable table(100, 5);

	cerr << "Adding First Column\n";
	table.AddColumn(table.NewColumn(4, 0, false, "Int32a"));

	cerr << "Adding Second Column\n";
	table.AddColumn(table.NewColumn(10, 0, false, "String10"));

	cerr << "Adding Third Column\n";
	table.AddColumn(table.NewColumn(1, 0, false, "Char"));

	cerr << "Adding Fourth Column\n";
	table.AddColumn(table.NewColumn(4, 0, false, "Int32b"));

	cerr << "Adding First Column\n";
	table.AddColumn(table.NewColumn(4, 0, false, "Int32c"));


	cerr << "Geting new row\n";
	void * row = table.NewRow();

	int a = 45;
	char  str[10];
	strcpy(str, "TEST");
	char ch = 'X';
	int b = 64;
	int c = 256;


	cerr << "Populating Row\n";
	table.EditRow(row, "Int32a", &a);
	table.EditRow(row, "String10", str);
	table.EditRow(row, "Char", &ch);
	table.EditRow(row, "Int32b", &b);
	table.EditRow(row, "Int32c", &c);

	cerr << "Adding Row to table\n";
	table.AddRow(row);

	row = table.NewRow();
	a = 25;
	strcpy(str, "KRATZ!");
	ch = 'Z';
	b = 45045454;
	c = -4;

	cerr << "Adding Second Row\n";
	table.EditRow(row, "Int32a", &a);
	table.EditRow(row, "String10", str);
	table.EditRow(row, "Char", &ch);
	table.EditRow(row, "Int32b", &b);
	table.EditRow(row, "Int32c", &c);

	table.AddRow(row);


	a = 45;

	cerr << "Finding row for Int32a == 45\n"; 
	LIST * res = table.FindRows("Int32a", &a);
	
	void * row1 = table.GetRow(res->link->value);
	table.DestroyList(res);

	cerr << "Geting Values\n";
	int geta=0;
	char getstr[13];
	table.GetColValue(row1, "Int32a", &geta);
	table.GetColValue(row1, "String10", getstr);

	cerr << "Got value for column 'Int32a': " << geta << "\n";
	cerr << "Got value for column 'String10': " << getstr << "\n";

	c=-4;
	cerr << "Finding row for Int32c == -4\n"; 
	res = table.FindRows("Int32c", &c);
	
	row1 = table.GetRow(res->link->value);

	table.DestroyList(res);

	cerr << "Geting Values\n";
	geta=0; 
	table.GetColValue(row1, "Int32a", &geta);
	table.GetColValue(row1, "String10", getstr);

	cerr << "Got value for column 'Int32a': " << geta << "\n";
	cerr << "Got value for column 'String10': " << getstr << "\n";

}